
#include	<stdio.h>
#include 	<unistd.h>
#include 	<time.h>
#include	<curses.h>
#include	<stdlib.h>
#include	<string.h>
#include 	"interface.h"

void 	main(void)
{
	int ch;
	int temp_index,k;
 	int ret = 0, flag0=0, flag1 = 0;
	int arr[] = { 6,5,16,15,8};
	int up_down = -1;
	char temp;
	
  	first=last=NULL;

	y = top;
	x = left;
	initscr ();
	start_color();
	draw_back_first (fcol,bcol);
	keypad (edit_sub_win, TRUE);
	status_menu();
	noecho();
	cbreak();
	cur = first = last = (NODE*) new NODE;
	while(1)
	{
		 width = 77 - (left +right);
		 height = 17- (top+bottom);
		
		// Set the scrolling region for Window
		 	wsetscrreg(edit_sub_win, top,bottom);
		
		if (up_down == 1)
			wmove(edit_sub_win,wy,x);
		else
			wmove (edit_sub_win,y,x);
		wrefresh(edit_sub_win);
		
		if (flag1) ch = arr[flag0];
		else       ch = wgetch( edit_sub_win);

		switch (ch)
		{
		case 6	:
			// Ctrl+f for File menu
			ret = menu_file();	flag0 = 0;	break;
		case 5	:
			// Ctrl+e for Edit menu			
			ret = menu_edit();	flag0 = 1;	break;
		case 16	:
			// Ctrl+p for  Page setup		
			ret = menu_setup();	flag0 = 2;	break;
		case 15	:
			// Ctrl+o for Options 	
			ret = menu_options();	flag0 = 3;	break;
		case 8	:
			// Ctrl+h for Help menu		
			ret = menu_help();	flag0 = 4;	break;
			
	// WHAT TO DO WHEN ARROW KEYS ARE PRESSED
	
	case KEY_LEFT	:
			up_down = -1;
			move_left();	break;
	case KEY_RIGHT	:
			up_down = -1;
			move_right();	break;
	case KEY_DOWN	:
			up_down = 1;
			move_down();	break;
	case KEY_UP	:
			up_down = 1;
			move_up();  	break;
	
	// WHAT TO DO WHEN FUNCTION KEYS F1 TO F6 ARE PRESSED
	
	case 265	:
			// F1 calls for help
			how2edit();	break;
	case 266	:
			// F2 Saves File
			file_save(1);	break;
	case 267	:
			// F3 Opens File
			file_open(1); 	break;
	case 268	:
			// F4 Deletes File on Disk
			file_delete();	break;
	case 269	:
			// F5 Changes Foreground color
			fcol = select_color();
			redraw();
			break;
	case 270	:
			// F6 Changes Background color
			bcol = select_color();
			redraw();
			break;
	case 274	:
	case 24		:
			// F10 or Ctrl+x Exits
			file_exit();	break;
			
	// ENTER KEY PRESSED
	
	case 10		:
			up_down = -1;
			enter();    	break;
	
	// HOME KEY PRESSED
	case 262	:
			up_down = -1;
			x=left; break;
			
	// BACKSPACE KEY PRESSED
	case 263	:
			up_down = -1;
			if (x == left) { beep(); break;}
			else
			{
				x--;
				char_del();
			}	
			break;
			
	// DELETE KEY PRESSED
	case 330	:
			up_down = -1;
			if (x == cur->index+1){ beep(); break;}
			else
			char_del();
			break;
			
	// END KEY PRESSED			
	case 360	:
			/* End */
			up_down = -1;
			x=cur->index ;

			break;
			
	// PG DOWN KEY PRESSED
	case 338	:
			page_down();
			break;
	
	// PG UP KEY PRESSED
	case 339	:
			page_up();
			break;
			
	// CTRL + Y TO DELETE LINE
	case 25		:
			del_ln();
			break;
			
	// TAB POSITION +4
	case 9		:
			for (i=0;i<3;i++)
			{
				waddch (edit_sub_win,' ');
				x++;
				cur->array[x] = ' ';
 /*ctrl t*/              case 20       :change_tab(edit_sub_win);break;	 	} 			
	// PRINTABLE CHARECTERS PRESSED
	
	 default	:
	 		x++;
	 		up_down = -1;
	 		if (x > width)
	 		{
	 		x = left;
	 		y++;
	 		}
	 		if (x <cur->index) word_ins(ch);
	 		else
	 		waddch(edit_sub_win,ch);
	 		cur->index++;
	 		cur->array[x] = (char)ch;
	 		file_saved = 0;
	 		status_menu();
	 	        break;

		}		
	draw_back (fcol, bcol);
	status_menu();
	
	// TO DRAW THE MENU WHEN LEFT OR RIGHT KEY USED
	// Circular Queue Logic Used to switch b/w Menus here
	
	flag0 = ( (ret == -1) ? flag1 = 1,(flag0 + 4) % 5 : ((ret == -2) ? flag1 = 1,(flag0 + 1) % 5 :flag1 = 0));
	
	 	
	 }
	endwin();		

} 
