	
	#include	<curses.h>
	#include	"file.h"
	
	#define no_cols 16	
	#define ENTER  	10	
	#define ESC 	27

	
// variables
		
int 	flag0;
int 	fcol = 2,bcol = 0;

// Function Prototypes



//NODE 	*file_new();
void    change_tab( WINDOW*);
void 	attrset_n_print( WINDOW* );
void	redraw();
void 	draw_back(int,int);
void	draw_back_first (int,int);
void 	status_menu();
int	draw_menu(char *[],int,int,int,int[]);
int 	menu_file();
int 	menu_edit();
int	menu_setup();
int 	select_color();
int 	menu_options();
int 	menu_help();

// Function Definitions
//--------------------------FILE MENU-------------------------------------------------	
int 	menu_file()
{
	int sel;
	char *menu[] = {" New         "," Open      F3"," Save      F2"," Delete    F4"," Exit     F10"};
	int no_rows = 7;
	int a[] = { 0,0,0,0,0};
	sel = draw_menu (menu, no_rows,1,0,a);
	
	switch (sel)
	{	
		
		case 0 :
			 return 0;

	 	case -1 :
	 		 return -1;
		case -2 :
		         return -2;
		case 1	:
			new_file();
			status_menu();
			return 0;
			break;
		case 2	:
			file_open(1);
			status_menu();
			return 0;
			break;
		case 3	:
			file_save(1);
			status_menu();
			return 0;
			break;
		case 4	:
			file_delete();
			status_menu();
			return 0;
			break;
		case 5	:
			file_exit();
			return 0;
		default :
			beep();
			return 0;
	}
}			

//--------------------------EDIT MENU--------------------------------------------------	
int 	menu_edit()
{
	int sel;
	char *menu[] = { " Insert Line"," Delete Line"," Insert Word"," Delete Word"," Select Tab"};
	int no_rows = 7;
	int a[] = {0,0,0,0,0};
	sel = draw_menu (menu, no_rows, 1,16,a);
        switch (sel)
	{	
		
		case 0 :
			return 0; break;
	 	case -1 :
	 		return -1; break;
		case -2 :
		        return -2; break;
		case 1	:
			ins_ln();
			break;
		case 2	:
			del_ln();
			break;
		case 3	:
//			word_ins();
			break;
		case 4	:
			word_del();
			status_menu();
			return 0;
               case 5: 
                        change_tab(edit_sub_win);
                        break;
                        return 0;
			
		default :
			beep();
			return 0;
	}
}

//-------------------------SETUP MENU---------------------------------------------------	
int 	menu_setup()
{
	int sel;
	char *menu[] = {" Left       ", " Right      "," Top        "," Bottom     " };
	int no_rows = 6;
	int a[] = {0,0,0,0};
	sel = draw_menu (menu, no_rows, 1,32,a);
        switch (sel)
	{	
		
		case 0 :
			 return 0; break;
	 	case -1 :
	 		 return -1; break;
		case -2 :
		         return -2; break;
		case 1	:
			left_margin();
			status_menu();
			return 0;
		case 2	:
			right_margin();
			status_menu();
			return 0;
		case 3	:
			top_margin();
			status_menu();
			return 0;
		case 4	:
			bottom_margin();
			status_menu();
			return 0;
		default :
			beep();
			return 0;
	}
	
}
//-------------------------OPTIONS MENU---------------------------------------------------	
int 	menu_options()
{
	int sel;
	char *menu[] = { " Foreground ", " Background "};
	int no_rows = 4;
	int a[] = {0,0};
	sel = draw_menu (menu, no_rows, 1,48,a);

        switch (sel)
	{	
		
		case 0	:
			return 0; break;
	 	case -1 :
		 	return -1; break;
		case -2 :
			return -2; break;
		case 1	:
			fcol = select_color();
			return 0;
                        break;
		case 2	:
			bcol = select_color();
			return 0;
		        break;
		default :
			beep();
			return 0;
	}
	redraw();
	return 0;
}

//-------------------------HELP MENU---------------------------------------------------	
int 	menu_help()
{
	int sel;
	char *menu[] = { " How to Edit ", " About "};
	int no_rows = 4;
	int a[] = { 0,0 };
	sel = draw_menu (menu, no_rows, 1,64,a);
         switch (sel)
	{	
		
		case 0 :
			 return 0; break;
	 	case -1 :
	 		 return -1; break;
		case -2 :
		         return -2; break;
		case 1	:
			how2edit();
			return 0;
		case 2	:
			about_us();
			return 0;
		default :
			beep();
			return 0;
	}
}
//-------------------------MENU DRAW (generalized for all fun.)---------------------------------------------------	
int 	draw_menu(char *menu[],
	       int no_rows,
	       int beg_y,
	       int beg_x,
	       int a[])
{
	int flag, sel ;
	WINDOW *win_menu = newwin ( no_rows, no_cols, beg_y, beg_x );
	start_color();

	init_pair(4,COLOR_BLACK,COLOR_WHITE);
	init_pair(5,COLOR_RED,COLOR_WHITE);

	keypad (win_menu ,TRUE);
	int key,i;
	wcolor_set(win_menu,4,NULL);
	wbkgd (win_menu, COLOR_PAIR(4));
	box (win_menu, ACS_VLINE, ACS_HLINE);
	
	for (i = 1 ; i < no_rows-1; i++)
	{
		mvwaddstr (win_menu, i,1, menu[i-1]);
		mvwchgat (win_menu, i,1+a[i-1],2,A_NORMAL,5,NULL);
	}
	wrefresh (win_menu);
	i = 1;
	int j = 1;
	while (TRUE)
	{
		mvwaddstr (win_menu, i, 1, menu[i-1]);
		mvwchgat (win_menu,i,1+a[i-1],no_cols,A_REVERSE,5,NULL);
		wrefresh (win_menu);
		key = wgetch (win_menu);
		j = i;
		switch (key)
		{
			case 	KEY_UP	  :	i = ( (i ==1 ) ? no_rows-2 : --i); break;
                        case	KEY_DOWN  :	i = ((i == no_rows-2) ? 1 : ++i) ; break;
			case 	ESC 	  :	return 0;break;
			case 	KEY_LEFT  :	return -1; break;
			case    KEY_RIGHT :	return -2; break;
			case 	10  	  :	return i;break;
			default		  :	beep();
			
		}
		mvwaddstr (win_menu,j,1+a[j-1], menu[j-1]);
		mvwchgat (win_menu, j,1+a[j-1],16,A_NORMAL,4,NULL);
		mvwchgat (win_menu, j,1+a[j-1],2,A_NORMAL,5,NULL);
	}
//	delwin (win_menu);
	overwrite ( win_menu ,edit_sub_win);
	touchwin (edit_main_win);
	wrefresh (edit_main_win);
	
}
//--------------------------INTERFACE 1--------------------------------------------------		
void 	draw_back_first(int fcol,int bcol)
{
	int i,j;
	char ch;
	char *menu_bar_text =
		" File \t\t Edit \t\t Page Setup\t Options \t Help";

	init_pair (1, fcol, bcol);
	init_pair (2, COLOR_BLACK, COLOR_WHITE);

	// Edit Window

	edit_main_win = newwin ( LINES-3, COLS, 1, 0);	
	edit_sub_win = subwin (edit_main_win, LINES-7,COLS-2, 2, 1);

	box (edit_main_win, ACS_VLINE, ACS_HLINE);
	wcolor_set (edit_main_win, 1, NULL);
	wcolor_set (edit_sub_win, 1, NULL);
	wbkgd (edit_main_win, COLOR_PAIR(1));
	wbkgd (edit_sub_win, COLOR_PAIR(1));
	wrefresh (edit_main_win);
	wrefresh (edit_sub_win);
	
	// MENU WINDOW
	menu_bar_win = newwin (1, COLS, 0, 0);
	wcolor_set (menu_bar_win, 2, NULL);
	wbkgd (menu_bar_win, COLOR_PAIR(2));
	wprintw (menu_bar_win, "%s", menu_bar_text);
	attrset_n_print( menu_bar_win);
	wrefresh (menu_bar_win);

}
//--------------------------INTERFACE 2--------------------------------------------------	
void 	draw_back(int fcol, int bcol)
{	
	init_pair (1, fcol, bcol);
	init_pair (2, COLOR_BLACK, COLOR_WHITE);
	box (edit_main_win, ACS_VLINE, ACS_HLINE);
	wcolor_set (edit_main_win, 1, NULL);
	wcolor_set (edit_sub_win, 1, NULL);
	wbkgd (edit_main_win, COLOR_PAIR(1));
	wbkgd (edit_sub_win, COLOR_PAIR(1));
	touchwin (edit_main_win);
	wrefresh (edit_main_win);
	touchwin (edit_sub_win);
	wrefresh (edit_sub_win);
}
//-------------------------STATUS-BAR N MENU-BAR---------------------------------------------------	
void 	status_menu()
{
	time_t cur_time;
	time(&cur_time);
	init_pair (2, COLOR_BLACK, COLOR_WHITE);
	
	// Status Window

	status_bar_win = subwin (stdscr, 1, COLS, 23, 0);
	wcolor_set (status_bar_win, 2, NULL);
	wbkgd (status_bar_win, COLOR_PAIR(2));
//	wclear (status_bar_win);
	mvwprintw (status_bar_win, 0, 0, " %d : %d ", y-top,x-left);
	if (file_saved)
	mvwprintw (status_bar_win, 0, 20,"%s Saved\t\t%s",filename,ctime (&cur_time));
	else
	mvwprintw (status_bar_win, 0, 20,"%s Unsaved\t\t%s",filename,ctime (&cur_time));	
	wrefresh (status_bar_win);
	
	// Menu Window
	attrset_n_print( menu_bar_win);
	wrefresh (menu_bar_win);
	
}
//--------------------------COLOR SELECTION POPUP--------------------------------------------------	
int 	select_color()
{
	char *list[] = { " Black", " Red", " Green", " Orange", " Blue", " Magenta", " Cyan", " White" };
	int no_rows = 10;
	static int a[8];
	int x, sel;
	x = draw_menu (list, no_rows, 2,64,a);
	switch (x)
	{	
		case 0:	break;
		case -1:
		case -2: beep();break;
		case 1:
		case 2:
		case 3:
		case 4:
		case 5:
		case 6:
		case 7:
		case 8:
			sel =  x-1;
			break;
		case 27 :
		default : break;
	}
	draw_back (fcol,bcol);
	keypad (edit_sub_win, TRUE);
	status_menu();
	return sel;
	return 7;
	
}
//---------------------REDRAW FOREGROUND OR BACKGROUND COLOR--------------------------------
void	redraw()
{
	init_pair (3,fcol, bcol);
	wcolor_set (edit_main_win, 3, NULL);
	wbkgd (edit_main_win, COLOR_PAIR(3));
	touchwin (edit_main_win);
	wrefresh (edit_main_win);
	touchwin (edit_sub_win);
	wrefresh (edit_sub_win);
	status_menu();
}
//-----------------------ATTRIBUTES FOR MENU-BAR-----------------------------------------------------	
void 	attrset_n_print(WINDOW *win)
{
	char put_char[] = {'F','E','P','O','H'};
	int i,j = 1;
	init_pair (3, COLOR_RED, COLOR_WHITE);
	wcolor_set( win, 3, NULL);
	attron(A_BOLD);
	for (i = 0; i < 5; i++) {
		mvwaddch (win, 0, j, put_char[i]);
		j += 16;
	}
	attroff(A_BOLD);
}

